const app = new (require('koa'))();
const router = require('koa-router')();
const axios = require('axios');
const koaStatic = require('koa-static');

// WizNote server
const API_URL = 'http://localhost:5001';

// TODO: change settings
const OAUTH_SETTINGS = {
  clientId: 'xxx',
  clientSecret: 'xxx',
};

async function getAccessToken() {
  //
  const {clientId, clientSecret} = OAUTH_SETTINGS;
  const url = `${API_URL}/as/oauth/token?clientId=${clientId}&clientSecret=${clientSecret}`;
  const response = await axios.get(url);
  const {data} = response;
  if (!data || data.returnCode != 200) {
    console.error(response);
    throw new Error('failed to get token');
  }
  return data.result.accessToken;
}

async function getLoginUrl(userId) {
  const accessToken = await getAccessToken();
  const url = `${API_URL}/as/oauth/service/login_url?accessToken=${accessToken}&userId=${userId}`;
  //
  const response = await axios.get(url);
  const {data} = response;
  if (!data || data.returnCode != 200) {
    console.error(response);
    throw new Error('failed to get login url');
  }
  const loginUrl = data.result;  
  return loginUrl;
}

router.get('/login/url', async (ctx, next) => {
  const query = ctx.query;
  const userId = query.userId;
  //
  // TODO: check user
  //
  const loginUrl = await getLoginUrl(userId);
  //
  ctx.body = loginUrl;
});

app
.use(router.routes())
.use(router.allowedMethods());

app
.use(koaStatic(__dirname + '/static'));

app.listen(8888);
